file(TO_CMAKE_PATH "${MCUXPRESSO_IDE_PATH}" MCUXPRESSO_IDE_PATH)
find_program(nxp_flash_tool NAMES crt_emu_cm_redlink
    PATHS
        "/usr/local/mcuxpressoide/ide/binaries"
        "${MCUXPRESSO_IDE_PATH}/ide/binaries"
        # this is for MacOS
        "${MCUXPRESSO_IDE_PATH}/binaries"
)

if(NOT nxp_flash_tool)
    message(STATUS "NXP_Flash_tool not found, make flash targets will be disabled!")
    message(STATUS "To enable, provide MCUXPRESSO_IDE_PATH cache entry pointing to install path of MCUXpressoIDE")
endif()

function(add_executable_hook name)
    qul_private_evaluate_path_from_target_property(prop_nxp_partfiles_dir Qul::Platform NXP_PARTFILES_DIR)
    set(get_nxp_chip_name      $<IF:$<BOOL:${NXP_CHIP_NAME}>,${NXP_CHIP_NAME},$<TARGET_PROPERTY:Qul::Platform,NXP_CHIP_NAME>>)
    set(get_nxp_connect_script $<IF:$<BOOL:${NXP_CONNECT_SCRIPT}>,${NXP_CONNECT_SCRIPT},$<TARGET_PROPERTY:Qul::Platform,NXP_CONNECT_SCRIPT>>)
    set(get_nxp_partfiles_dir  $<IF:$<BOOL:${NXP_PARTFILES_DIR}>,${NXP_PARTFILES_DIR},${prop_nxp_partfiles_dir}>)
    set(get_nxp_reset_script   $<IF:$<BOOL:${NXP_RESET_SCRIPT}>,--resetscript=${NXP_RESET_SCRIPT},$<$<BOOL:$<TARGET_PROPERTY:Qul::Platform,NXP_RESET_SCRIPT>>:--resetscript=$<TARGET_PROPERTY:Qul::Platform,NXP_RESET_SCRIPT>>>)

    if (NOT nxp_flash_tool)
        message(STATUS "NXP_Flash_tool not found, won't generate flash targets for ${name}")
    else()
        add_custom_target("flash_${name}" COMMAND ${nxp_flash_tool} -g --flash-load-exec "$<TARGET_FILE_DIR:${name}>/${name}.elf" -p ${get_nxp_chip_name} --ConnectScript ${get_nxp_connect_script} -x ${get_nxp_partfiles_dir} ${get_nxp_reset_script} USES_TERMINAL)
        message(STATUS "Added flash target flash_${name}")
    endif()
endfunction()
